// ChartDemoDialog.cpp : implementation file
//

#include "stdafx.h"
#include "chart.h"
#include "ChartDemoDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CChartDemoDialog dialog


CChartDemoDialog::CChartDemoDialog(CWnd* pParent /*=NULL*/)
	: CDialog(CChartDemoDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(CChartDemoDialog)
	m_CheckColor        = true;
	m_CheckIcon         = FALSE;
    m_IsHorz            = true;
	m_CheckButtonBack   = FALSE;
	m_CheckEdge         = true;
	m_GridIndex = 0;
	m_strUserTitle = _T("");
	//}}AFX_DATA_INIT
}


void CChartDemoDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CChartDemoDialog)
	DDX_Control(pDX, IDC_CHART, m_ChartWnd);
	DDX_Control(pDX, IDC_BUTTON_COLOR, m_ColorButton);
	DDX_Check(pDX, IDC_CHECK_BACKCOLOR, m_CheckColor);
	DDX_Check(pDX, IDC_CHECK_ICON, m_CheckIcon);
    DDX_Radio(pDX, IDC_RADIO_VERTICAL, m_IsHorz);
	DDX_Check(pDX, IDC_CHECK_USER_BACK, m_CheckButtonBack);
	DDX_Check(pDX, IDC_CHECK_EDGE, m_CheckEdge);
	DDX_CBIndex(pDX, IDC_COMBO_GRID, m_GridIndex);
	DDX_Text(pDX, IDC_EDIT_USER_TITLE, m_strUserTitle);
	DDV_MaxChars(pDX, m_strUserTitle, 20);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CChartDemoDialog, CDialog)
	//{{AFX_MSG_MAP(CChartDemoDialog)
	ON_BN_CLICKED(IDC_CHECK_BACKCOLOR, OnCheckBackcolor)
	ON_BN_CLICKED(IDC_CHECK_ICON, OnCheckIcon)
	ON_BN_CLICKED(IDC_RADIO_HORZ, OnRadioHorz)
	ON_BN_CLICKED(IDC_RADIO_VERTICAL, OnRadioVertical)
	ON_BN_CLICKED(IDC_BUTTON_ADD, OnButtonAdd)
	ON_BN_CLICKED(IDC_BUTTON_COLOR, OnButtonColor)
	ON_BN_CLICKED(IDC_BUTTON_REMOVE, OnButtonRemove)
	ON_BN_CLICKED(IDC_CHECK_USER_BACK, OnCheckUserBack)
	ON_BN_CLICKED(IDC_CHECK_EDGE, OnCheckEdge)
    ON_MESSAGE(MESSAGE_COLOR_CHANGED,OnColorChanged)
	ON_CBN_SELCHANGE(IDC_COMBO_GRID, OnSelchangeComboGrid)
	ON_BN_CLICKED(IDC_BUTTON_USER_TITLE, OnButtonUserTitle)

	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()

	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CChartDemoDialog message handlers
void CChartDemoDialog::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CChartDemoDialog::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CChartDemoDialog::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

BOOL CChartDemoDialog::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
    if(!m_ChartWnd.Initialize())
        return false;

    m_ColorButton.EnableWindow(m_CheckColor);  	
    m_ColorButton.SetColor(m_ChartWnd.GetTextBkColor());

    m_IsHorz            =   m_ChartWnd.GetChartDirection();
    m_GridIndex         =   m_ChartWnd.GetGridLines();
    m_strUserTitle      =   m_ChartWnd.GetUserColTitle();

    UpdateData(false);


	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


/*********************************************************************
 *
 *
 *
 *********************************************************************/
void CChartDemoDialog::OnCheckIcon() 
{
	// TODO: Add your control notification handler code here
	
}

void CChartDemoDialog::OnRadioHorz() 
{
    m_ChartWnd.SetChartHorz();
    m_ChartWnd.RefreshWindow();
}

void CChartDemoDialog::OnRadioVertical() 
{
    m_ChartWnd.SetChartVert();
    m_ChartWnd.RefreshWindow();
}

void CChartDemoDialog::OnButtonAdd() 
{

}

void CChartDemoDialog::OnButtonColor() 
{
	
}

void CChartDemoDialog::OnCheckBackcolor() 
{
	UpdateData(true);
    m_ColorButton.EnableWindow(m_CheckColor);  	

    if(!m_CheckColor)
        m_ChartWnd.SetNoBackColor();
    else
        m_ChartWnd.SetTextBkColor(m_ColorButton.GetColor());

    m_ChartWnd.RefreshWindow();
}

void CChartDemoDialog::OnButtonRemove() 
{
	
}

void CChartDemoDialog::OnCheckUserBack() 
{
    UpdateData(true);

    m_ChartWnd.SetUserNameBackState(m_CheckButtonBack);
    m_ChartWnd.RefreshWindow();
}

void CChartDemoDialog::OnCheckEdge() 
{
    UpdateData(true);
    
    m_ChartWnd.SetEdgeState(m_CheckEdge);
    m_ChartWnd.RefreshWindow();
}


void CChartDemoDialog::OnColorChanged(WPARAM, LPARAM)
{
    m_ChartWnd.SetTextBkColor(m_ColorButton.GetColor());
    m_ChartWnd.RefreshWindow();
}

void CChartDemoDialog::OnSelchangeComboGrid() 
{
    UpdateData(true);

    m_ChartWnd.SetGridLines(m_GridIndex);
    m_ChartWnd.RefreshWindow();
}

void CChartDemoDialog::OnButtonUserTitle() 
{
    UpdateData(true);
    
    if(m_ChartWnd.SetUserColTitle(m_strUserTitle))
        m_ChartWnd.RefreshWindow();
}

